	.reference	___bb_blitz_blitz
	.reference	___bb_imports_constants
	.reference	___bb_imports_entity
	.reference	__bb_TEntity_gMaxZ
	.reference	__bb_TEntity_gMinZ
	.reference	_bbFloatToInt
	.reference	_bbGCFree
	.reference	_bbNullObject
	.reference	_bbObjectClass
	.reference	_bbObjectCompare
	.reference	_bbObjectCtor
	.reference	_bbObjectFree
	.reference	_bbObjectNew
	.reference	_bbObjectRegisterType
	.reference	_bbObjectReserved
	.reference	_bbObjectSendMessage
	.reference	_bbObjectToString
	.reference	_bbStringClass
	.reference	_brl_max2d_DrawImage
	.reference	_brl_max2d_ImageHeight
	.reference	_brl_max2d_ImageWidth
	.reference	_brl_max2d_LoadImage
	.reference	_brl_max2d_SetAlpha
	.reference	_brl_max2d_SetBlend
	.reference	_brl_max2d_SetColor
	.reference	_brl_max2d_SetImageHandle
	.reference	_brl_max2d_SetScale
	.reference	_brl_random_Rnd
	.globl	___bb_imports_cloud
	.globl	__bb_TCloud_Create
	.globl	__bb_TCloud_Delete
	.globl	__bb_TCloud_New
	.globl	__bb_TCloud_addToListDepthSorted
	.globl	__bb_TCloud_draw
	.globl	__bb_TCloud_drawAll
	.globl	__bb_TCloud_gFirst
	.globl	__bb_TCloud_gGfxCloud1
	.globl	__bb_TCloud_gHorizonYOffset
	.globl	__bb_TCloud_gHorizontalSpeed
	.globl	__bb_TCloud_gLast
	.globl	__bb_TCloud_hittable
	.globl	__bb_TCloud_loadGraphics
	.globl	__bb_TCloud_removeAll
	.globl	__bb_TCloud_update
	.globl	__bb_TCloud_updateAll
	.globl	_bb_TCloud
	.text	
___bb_imports_cloud:
	push	%ebp
	mov	%esp,%ebp
	sub	$8,%esp
	cmpl	$0,_79
	je	_80
	mov	$0,%eax
	mov	%ebp,%esp
	pop	%ebp
	ret
_80:
	movl	$1,_79
	call	___bb_blitz_blitz
	call	___bb_imports_constants
	call	___bb_imports_entity
	movl	$_bb_TCloud,(%esp)
	call	_bbObjectRegisterType
	mov	$0,%eax
	jmp	_46
_46:
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_New:
	push	%ebp
	mov	%esp,%ebp
	push	%ebx
	sub	$4,%esp
	movl	8(%ebp),%ebx
	movl	%ebx,(%esp)
	call	_bbObjectCtor
	movl	$_bb_TCloud,(%ebx)
	fldz
	fstps	8(%ebx)
	fldz
	fstps	12(%ebx)
	fldz
	fstps	16(%ebx)
	mov	$_bbNullObject,%eax
	incl	4(%eax)
	movl	%eax,20(%ebx)
	movl	$0,24(%ebx)
	fldz
	fstps	28(%ebx)
	fldz
	fstps	32(%ebx)
	mov	$_bbNullObject,%eax
	incl	4(%eax)
	movl	%eax,36(%ebx)
	mov	$_bbNullObject,%eax
	incl	4(%eax)
	movl	%eax,40(%ebx)
	mov	$0,%eax
	jmp	_49
_49:
	add	$4,%esp
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_Delete:
	push	%ebp
	mov	%esp,%ebp
	push	%ebx
	sub	$4,%esp
	movl	8(%ebp),%ebx
_52:
	movl	40(%ebx),%eax
	decl	4(%eax)
	jnz	_86
	movl	%eax,(%esp)
	call	_bbGCFree
_86:
	movl	36(%ebx),%eax
	decl	4(%eax)
	jnz	_88
	movl	%eax,(%esp)
	call	_bbGCFree
_88:
	movl	20(%ebx),%eax
	decl	4(%eax)
	jnz	_90
	movl	%eax,(%esp)
	call	_bbGCFree
_90:
	mov	$0,%eax
	jmp	_84
_84:
	add	$4,%esp
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_Create:
	push	%ebp
	mov	%esp,%ebp
	push	%ebx
	push	%esi
	sub	$16,%esp
	movl	$_bb_TCloud,(%esp)
	call	_bbObjectNew
	mov	%eax,%ebx
	fldl	_173
	fstpl	8(%esp)
	fldl	_174
	fstpl	(%esp)
	call	_brl_random_Rnd
	fstps	12(%ebx)
	flds	__bb_TEntity_gMaxZ
	fmuls	_175
	fstpl	8(%esp)
	flds	__bb_TEntity_gMaxZ
	fmuls	_176
	fstpl	(%esp)
	call	_brl_random_Rnd
	fstps	8(%ebx)
	movl	__bb_TCloud_gGfxCloud1,%eax
	incl	4(%eax)
	mov	%eax,%esi
	movl	20(%ebx),%eax
	decl	4(%eax)
	jnz	_95
	movl	%eax,(%esp)
	call	_bbGCFree
_95:
	movl	%esi,20(%ebx)
	flds	_177
	flds	8(%ebx)
	fsubs	__bb_TEntity_gMinZ
	flds	__bb_TEntity_gMaxZ
	fsubs	__bb_TEntity_gMinZ
	fdivrp	%st(0),%st(1)
	fsubrp	%st(0),%st(1)
	fmuls	_178
	fmuls	_179
	fstpl	(%esp)
	call	_bbFloatToInt
	movl	%eax,24(%ebx)
	flds	_180
	flds	8(%ebx)
	fsubs	__bb_TEntity_gMinZ
	flds	__bb_TEntity_gMaxZ
	fsubs	__bb_TEntity_gMinZ
	fdivrp	%st(0),%st(1)
	fsubrp	%st(0),%st(1)
	fstps	16(%ebx)
	flds	_181
	flds	__bb_TEntity_gMaxZ
	fsubs	8(%ebx)
	fmuls	_182
	faddp	%st(0),%st(1)
	fstps	28(%ebx)
	fld1
	fstps	32(%ebx)
	flds	8(%ebx)
	flds	__bb_TEntity_gMaxZ
	fmuls	_183
	fxch	%st(1)
	fucompp
	fnstsw	%ax
	sahf
	setbe	%al
	movzbl	%al,%eax
	cmp	$0,%eax
	jne	_96
	flds	_184
	flds	8(%ebx)
	flds	__bb_TEntity_gMaxZ
	fmuls	_185
	fsubrp	%st(0),%st(1)
	flds	__bb_TEntity_gMaxZ
	fmuls	_186
	fdivrp	%st(0),%st(1)
	fsubrp	%st(0),%st(1)
	fstps	32(%ebx)
	flds	32(%ebx)
	flds	_187
	fxch	%st(1)
	fucompp
	fnstsw	%ax
	sahf
	setae	%al
	movzbl	%al,%eax
	cmp	$0,%eax
	jne	_97
	flds	_188
	fstps	32(%ebx)
_97:
_96:
	mov	%ebx,%eax
	movl	%eax,(%esp)
	movl	(%eax),%eax
	calll	*68(%eax)
	mov	%ebx,%eax
	jmp	_54
_54:
	add	$16,%esp
	pop	%esi
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_loadGraphics:
	push	%ebp
	mov	%esp,%ebp
	sub	$4,%esp
	push	%ebx
	sub	$16,%esp
	movl	$-1,4(%esp)
	movl	$_7,(%esp)
	call	_brl_max2d_LoadImage
	incl	4(%eax)
	mov	%eax,%ebx
	movl	__bb_TCloud_gGfxCloud1,%eax
	decl	4(%eax)
	jnz	_102
	movl	%eax,(%esp)
	call	_bbGCFree
_102:
	movl	%ebx,__bb_TCloud_gGfxCloud1
	movl	__bb_TCloud_gGfxCloud1,%eax
	movl	%eax,(%esp)
	call	_brl_max2d_ImageHeight
	movl	%eax,-4(%ebp)
	fildl	-4(%ebp)
	fstps	8(%esp)
	movl	__bb_TCloud_gGfxCloud1,%eax
	movl	%eax,(%esp)
	call	_brl_max2d_ImageWidth
	cdq
	and	$1,%edx
	add	%edx,%eax
	sar	$1,%eax
	movl	%eax,-4(%ebp)
	fildl	-4(%ebp)
	fstps	4(%esp)
	movl	__bb_TCloud_gGfxCloud1,%eax
	movl	%eax,(%esp)
	call	_brl_max2d_SetImageHandle
	mov	$0,%eax
	jmp	_56
_56:
	add	$16,%esp
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_updateAll:
	push	%ebp
	mov	%esp,%ebp
	push	%ebx
	sub	$4,%esp
	flds	8(%ebp)
	flds	12(%ebp)
	flds	16(%ebp)
	fxch	%st(2)
	fmulp	%st(0),%st(1)
	fstps	__bb_TCloud_gHorizontalSpeed
	fstps	__bb_TCloud_gHorizonYOffset
	movl	__bb_TCloud_gFirst,%ebx
	jmp	_8
_10:
	movl	%ebx,(%esp)
	movl	(%ebx),%eax
	calll	*72(%eax)
	movl	40(%ebx),%ebx
_8:
	cmp	$_bbNullObject,%ebx
	jne	_10
_9:
	mov	$0,%eax
	jmp	_61
_61:
	add	$4,%esp
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_drawAll:
	push	%ebp
	mov	%esp,%ebp
	push	%ebx
	sub	$4,%esp
	movl	__bb_TCloud_gLast,%ebx
	jmp	_11
_13:
	movl	%ebx,(%esp)
	movl	(%ebx),%eax
	calll	*76(%eax)
	movl	36(%ebx),%ebx
_11:
	cmp	$_bbNullObject,%ebx
	jne	_13
_12:
	mov	$0,%eax
	jmp	_63
_63:
	add	$4,%esp
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_removeAll:
	push	%ebp
	mov	%esp,%ebp
	push	%ebx
	sub	$4,%esp
	mov	$_bbNullObject,%ebx
	incl	4(%ebx)
	movl	__bb_TCloud_gFirst,%eax
	decl	4(%eax)
	jnz	_110
	movl	%eax,(%esp)
	call	_bbGCFree
_110:
	movl	%ebx,__bb_TCloud_gFirst
	mov	$_bbNullObject,%ebx
	incl	4(%ebx)
	movl	__bb_TCloud_gLast,%eax
	decl	4(%eax)
	jnz	_114
	movl	%eax,(%esp)
	call	_bbGCFree
_114:
	movl	%ebx,__bb_TCloud_gLast
	mov	$0,%eax
	jmp	_65
_65:
	add	$4,%esp
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_addToListDepthSorted:
	push	%ebp
	mov	%esp,%ebp
	push	%ebx
	push	%esi
	push	%edi
	sub	$12,%esp
	movl	8(%ebp),%edi
	cmpl	$_bbNullObject,__bb_TCloud_gFirst
	jne	_115
	mov	%edi,%eax
	incl	4(%eax)
	mov	%eax,%ebx
	movl	__bb_TCloud_gFirst,%eax
	decl	4(%eax)
	jnz	_119
	movl	%eax,(%esp)
	call	_bbGCFree
_119:
	movl	%ebx,__bb_TCloud_gFirst
	mov	%edi,%ebx
	incl	4(%ebx)
	movl	__bb_TCloud_gLast,%eax
	decl	4(%eax)
	jnz	_123
	movl	%eax,(%esp)
	call	_bbGCFree
_123:
	movl	%ebx,__bb_TCloud_gLast
	jmp	_124
_115:
	movl	__bb_TCloud_gLast,%ebx
	jmp	_14
_16:
	movl	36(%ebx),%ebx
_14:
	cmp	$_bbNullObject,%ebx
	setne	%al
	movzbl	%al,%eax
	cmp	$0,%eax
	je	_126
	flds	8(%ebx)
	flds	8(%edi)
	fxch	%st(1)
	fucompp
	fnstsw	%ax
	sahf
	seta	%al
	movzbl	%al,%eax
_126:
	cmp	$0,%eax
	jne	_16
_15:
	cmp	$_bbNullObject,%ebx
	jne	_128
	mov	%edi,%eax
	incl	4(%eax)
	mov	%eax,%ebx
	movl	__bb_TCloud_gFirst,%eax
	movl	36(%eax),%eax
	decl	4(%eax)
	jnz	_132
	movl	%eax,(%esp)
	call	_bbGCFree
_132:
	movl	__bb_TCloud_gFirst,%eax
	movl	%ebx,36(%eax)
	movl	__bb_TCloud_gFirst,%eax
	incl	4(%eax)
	mov	%eax,%ebx
	movl	40(%edi),%eax
	decl	4(%eax)
	jnz	_136
	movl	%eax,(%esp)
	call	_bbGCFree
_136:
	movl	%ebx,40(%edi)
	mov	%edi,%ebx
	incl	4(%ebx)
	movl	__bb_TCloud_gFirst,%eax
	decl	4(%eax)
	jnz	_140
	movl	%eax,(%esp)
	call	_bbGCFree
_140:
	movl	%ebx,__bb_TCloud_gFirst
	jmp	_141
_128:
	cmpl	$_bbNullObject,40(%ebx)
	je	_142
	mov	%edi,%eax
	incl	4(%eax)
	mov	%eax,%esi
	movl	40(%ebx),%eax
	movl	36(%eax),%eax
	decl	4(%eax)
	jnz	_146
	movl	%eax,(%esp)
	call	_bbGCFree
_146:
	movl	40(%ebx),%eax
	movl	%esi,36(%eax)
	jmp	_147
_142:
	mov	%edi,%eax
	incl	4(%eax)
	mov	%eax,%esi
	movl	__bb_TCloud_gLast,%eax
	decl	4(%eax)
	jnz	_151
	movl	%eax,(%esp)
	call	_bbGCFree
_151:
	movl	%esi,__bb_TCloud_gLast
_147:
	mov	%ebx,%eax
	incl	4(%eax)
	mov	%eax,%esi
	movl	36(%edi),%eax
	decl	4(%eax)
	jnz	_155
	movl	%eax,(%esp)
	call	_bbGCFree
_155:
	movl	%esi,36(%edi)
	movl	40(%ebx),%eax
	incl	4(%eax)
	mov	%eax,%esi
	movl	40(%edi),%eax
	decl	4(%eax)
	jnz	_159
	movl	%eax,(%esp)
	call	_bbGCFree
_159:
	movl	%esi,40(%edi)
	mov	%edi,%eax
	incl	4(%eax)
	mov	%eax,%esi
	movl	40(%ebx),%eax
	decl	4(%eax)
	jnz	_163
	movl	%eax,(%esp)
	call	_bbGCFree
_163:
	movl	%esi,40(%ebx)
_141:
_124:
	mov	$0,%eax
	jmp	_68
_68:
	add	$12,%esp
	pop	%edi
	pop	%esi
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_update:
	push	%ebp
	mov	%esp,%ebp
	sub	$8,%esp
	movl	8(%ebp),%edx
	flds	12(%edx)
	flds	__bb_TCloud_gHorizontalSpeed
	fmuls	28(%edx)
	fsubrp	%st(0),%st(1)
	fstps	12(%edx)
	flds	12(%edx)
	flds	_208
	fxch	%st(1)
	fucompp
	fnstsw	%ax
	sahf
	setae	%al
	movzbl	%al,%eax
	cmp	$0,%eax
	jne	_164
	flds	_209
	fstps	12(%edx)
_164:
	flds	12(%edx)
	flds	_210
	fxch	%st(1)
	fucompp
	fnstsw	%ax
	sahf
	setbe	%al
	movzbl	%al,%eax
	cmp	$0,%eax
	jne	_165
	flds	_211
	fstps	12(%edx)
_165:
	mov	$0,%eax
	jmp	_71
_71:
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_draw:
	push	%ebp
	mov	%esp,%ebp
	sub	$4,%esp
	push	%ebx
	sub	$16,%esp
	movl	8(%ebp),%ebx
	movl	$3,(%esp)
	call	_brl_max2d_SetBlend
	flds	16(%ebx)
	fstps	4(%esp)
	flds	16(%ebx)
	fstps	(%esp)
	call	_brl_max2d_SetScale
	movl	$255,8(%esp)
	movl	$255,4(%esp)
	movl	$255,(%esp)
	call	_brl_max2d_SetColor
	flds	32(%ebx)
	fstps	(%esp)
	call	_brl_max2d_SetAlpha
	movl	$0,12(%esp)
	mov	$300,%eax
	subl	24(%ebx),%eax
	movl	%eax,-4(%ebp)
	fildl	-4(%ebp)
	fadds	__bb_TCloud_gHorizonYOffset
	fstps	8(%esp)
	flds	12(%ebx)
	fstps	4(%esp)
	movl	20(%ebx),%eax
	movl	%eax,(%esp)
	call	_brl_max2d_DrawImage
	fld1
	fstps	(%esp)
	call	_brl_max2d_SetAlpha
	movl	$1,(%esp)
	call	_brl_max2d_SetBlend
	mov	$0,%eax
	jmp	_74
_74:
	add	$16,%esp
	pop	%ebx
	mov	%ebp,%esp
	pop	%ebp
	ret
__bb_TCloud_hittable:
	push	%ebp
	mov	%esp,%ebp
	sub	$8,%esp
	mov	$0,%eax
	jmp	_77
_77:
	mov	%ebp,%esp
	pop	%ebp
	ret
	.data	
	.align	4
_79:
	.long	0
	.align	4
__bb_TCloud_gGfxCloud1:
	.long	_bbNullObject
	.align	4
__bb_TCloud_gFirst:
	.long	_bbNullObject
	.align	4
__bb_TCloud_gLast:
	.long	_bbNullObject
	.align	4
__bb_TCloud_gHorizontalSpeed:
	.long	0x0
	.align	4
__bb_TCloud_gHorizonYOffset:
	.long	0x0
_18:
	.asciz	"TCloud"
_19:
	.asciz	"fZ"
_20:
	.asciz	"f"
_21:
	.asciz	"fX"
_22:
	.asciz	"fScale"
_23:
	.asciz	"fGfx"
_24:
	.asciz	":TImage"
_25:
	.asciz	"fHeight"
_26:
	.asciz	"i"
_27:
	.asciz	"fSpeed"
_28:
	.asciz	"fAlpha"
_29:
	.asciz	"fPrevious"
_30:
	.asciz	":TCloud"
_31:
	.asciz	"fNext"
_32:
	.asciz	"New"
_33:
	.asciz	"()i"
_34:
	.asciz	"Delete"
_35:
	.asciz	"Create"
_36:
	.asciz	"():TCloud"
_37:
	.asciz	"loadGraphics"
_38:
	.asciz	"updateAll"
_39:
	.asciz	"(f,f,f)i"
_40:
	.asciz	"drawAll"
_41:
	.asciz	"removeAll"
_42:
	.asciz	"addToListDepthSorted"
_43:
	.asciz	"update"
_44:
	.asciz	"draw"
_45:
	.asciz	"hittable"
	.align	4
_17:
	.long	2
	.long	_18
	.long	3
	.long	_19
	.long	_20
	.long	8
	.long	3
	.long	_21
	.long	_20
	.long	12
	.long	3
	.long	_22
	.long	_20
	.long	16
	.long	3
	.long	_23
	.long	_24
	.long	20
	.long	3
	.long	_25
	.long	_26
	.long	24
	.long	3
	.long	_27
	.long	_20
	.long	28
	.long	3
	.long	_28
	.long	_20
	.long	32
	.long	3
	.long	_29
	.long	_30
	.long	36
	.long	3
	.long	_31
	.long	_30
	.long	40
	.long	6
	.long	_32
	.long	_33
	.long	16
	.long	6
	.long	_34
	.long	_33
	.long	20
	.long	7
	.long	_35
	.long	_36
	.long	48
	.long	7
	.long	_37
	.long	_33
	.long	52
	.long	7
	.long	_38
	.long	_39
	.long	56
	.long	7
	.long	_40
	.long	_33
	.long	60
	.long	7
	.long	_41
	.long	_33
	.long	64
	.long	6
	.long	_42
	.long	_33
	.long	68
	.long	6
	.long	_43
	.long	_33
	.long	72
	.long	6
	.long	_44
	.long	_33
	.long	76
	.long	6
	.long	_45
	.long	_33
	.long	80
	.long	0
	.align	4
_bb_TCloud:
	.long	_bbObjectClass
	.long	_bbObjectFree
	.long	_17
	.long	44
	.long	__bb_TCloud_New
	.long	__bb_TCloud_Delete
	.long	_bbObjectToString
	.long	_bbObjectCompare
	.long	_bbObjectSendMessage
	.long	_bbObjectReserved
	.long	_bbObjectReserved
	.long	_bbObjectReserved
	.long	__bb_TCloud_Create
	.long	__bb_TCloud_loadGraphics
	.long	__bb_TCloud_updateAll
	.long	__bb_TCloud_drawAll
	.long	__bb_TCloud_removeAll
	.long	__bb_TCloud_addToListDepthSorted
	.long	__bb_TCloud_update
	.long	__bb_TCloud_draw
	.long	__bb_TCloud_hittable
	.align	8
_173:
	.long	0x0,0x40990000
	.align	8
_174:
	.long	0x0,0xc0890000
	.align	4
_175:
	.long	0x3f666666
	.align	4
_176:
	.long	0x3f19999a
	.align	4
_177:
	.long	0x3f800000
	.align	4
_178:
	.long	0x44160000
	.align	4
_179:
	.long	0x3f000000
	.align	4
_180:
	.long	0x3f800000
	.align	4
_181:
	.long	0x459c4000
	.align	4
_182:
	.long	0x42700000
	.align	4
_183:
	.long	0x3f333333
	.align	4
_184:
	.long	0x3f800000
	.align	4
_185:
	.long	0x3f333333
	.align	4
_186:
	.long	0x3e99999a
	.align	4
_187:
	.long	0x3f000000
	.align	4
_188:
	.long	0x3f000000
	.align	4
_7:
	.long	_bbStringClass
	.long	2147483647
	.long	19
	.short	71,114,97,112,104,105,99,115,47,99,108,111,117,100,49,46
	.short	112,110,103
	.align	4
_208:
	.long	0xc4480000
	.align	4
_209:
	.long	0x44c80000
	.align	4
_210:
	.long	0x44c80000
	.align	4
_211:
	.long	0xc4480000
